## eeshow 0.git20170731

=== Makefile ===
#
# Makefile - build eeshow
#
# Written 2016 by Werner Almesberger
# Copyright 2016 by Werner Almesberger
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#

SHELL = /bin/bash

PREFIX ?= /usr/local

NAME = eeshow

OBJS_KICAD = \
	kicad/sch-parse.o kicad/sch-render.o kicad/lib-parse.o \
	kicad/lib-render.o kicad/dwg.o kicad/delta.o kicad/sexpr.o \
	kicad/pl-parse.o kicad/pl-render.o kicad/ext.o kicad/pro.o
OBJS_FILE = \
	file/file.o file/git-util.o file/git-file.o file/git-hist.o
OBJS_MISC = \
	misc/diag.o misc/util.o

EESHOW_OBJS = main/eeshow.o main/common.o \
	$(OBJS_KICAD) \
	gui/gui.o gui/over.o gui/style.o gui/aoi.o gui/fmt-pango.o gui/input.o \
	gui/progress.o gui/glabel.o gui/sheet.o gui/history.o gui/render.o \
	gui/help.o gui/icons.o gui/index.o gui/timer.o gui/pop.o gui/comp.o \
	gui/viewer.o gui/clipboard.o gui/view.o \
	$(OBJS_FILE) \
	gfx/style.o gfx/fig.o gfx/record.o gfx/cro.o gfx/diff.o gfx/gfx.o \
	gfx/text.o gfx/misc.o gfx/pdftoc.o \
	db/doc.o \
	$(OBJS_MISC)
EEPLOT_OBJS = main/eeplot.o main/common.o \
	$(OBJS_KICAD) \
	$(OBJS_FILE) \
	gfx/style.o gfx/fig.o gfx/record.o gfx/cro.o gfx/gfx.o \
	gfx/text.o gfx/misc.o gfx/pdftoc.o \
	$(OBJS_MISC)
EEDIFF_OBJS = main/eediff.o main/common.o \
	$(OBJS_KICAD) \
	$(OBJS_FILE) \
	gfx/style.o gfx/record.o gfx/cro.o gfx/diff.o gfx/gfx.o \
	gfx/text.o gfx/misc.o gfx/pdftoc.o \
	$(OBJS_MISC)
EETEST_OBJS = main/eetest.o main/common.o \
	kicad/sexpr.o \
	kicad/pl-render.o gfx/gfx.o gfx/text.o gfx/misc.o \
	gui/fmt-pango.o \
	$(OBJS_FILE) \
	$(OBJS_MISC)

# we need this for "clean" and dependencies
OBJS = $(EESHOW_OBJS) $(EEPLOT_OBJS) $(EEDIFF_OBJS) $(EETEST_OBJS)

ICONS = delta diff

CFLAGS = -g  -Wall -Wextra -Wno-unused-parameter -Wshadow \
	 -Wmissing-prototypes -Wmissing-declarations \
	 -I. \
	 `pkg-config --cflags cairo` \
	 `pkg-config --cflags libgit2` \
	 `pkg-config --cflags gtk+-3.0`
LDLIBS = -lm \
	 `pkg-config --libs cairo` \
	 `pkg-config --libs libgit2` \
	 `pkg-config --libs gtk+-3.0`

GIT_VERSION = $(shell git log -1 --format='%h' -s .)
GIT_STATUS = $(shell [ -z "`git status -s -uno`" ] || echo +)
BUILD_DATE = $(shell date -u +'%Y%m%d-%H:%MZ')

CFLAGS += -DVERSION='"$(GIT_VERSION)$(GIT_STATUS)"' \
	  -DBUILD_DATE='"$(BUILD_DATE)"'

include Makefile.c-common

.PHONY:		test neo900 sch test testref png pngref pdf diff view newref
.PHONY:		leak install uninstall

all::		eeshow eeplot eediff eetest

#
# We use order-only prerequisites to serialize linking. This is to ensure that
# a parallel make run won't try to compile version.o more than once at the same
# time, possibly producing corrupted output.
#

eeshow:		$(EESHOW_OBJS)
		$(MAKE) -B version.o
		$(CC) -o $@ $(EESHOW_OBJS) version.o $(LDLIBS)

eeplot:		$(EEPLOT_OBJS) | eeshow
		$(MAKE) -B version.o
		$(CC) -o $@ $(EEPLOT_OBJS) version.o $(LDLIBS)

eediff:		$(EEDIFF_OBJS) | eeplot
		$(MAKE) -B version.o
		$(CC) -o $@ $(EEDIFF_OBJS) version.o $(LDLIBS)

eetest:		$(EETEST_OBJS) | eediff
		$(MAKE) -B version.o
		$(CC) -o $@ $(EETEST_OBJS) version.o $(LDLIBS)

#----- Help texts -------------------------------------------------------------

help.inc:	help.txt Makefile
		$(BUILD) sed 's/"/\\"/g;s/.*/"&\\n"/' $< >$@ || \
		    { rm -f $@; exit 1; }

gui/help.c:	help.inc

clean::
		rm -f help.inc

#----- Icons ------------------------------------------------------------------

icons/%.hex:	icons/%.fig Makefile
		$(BUILD) fig2dev -L png -S 4 -Z 0.60 $< | \
		    convert - -transparent white - | \
		    hexdump -v -e '/1 "0x%x, "' >$@; \
		    [ "$${PIPESTATUS[*]}" = "0 0 0" ] || { rm -f $@; exit 1; }

gui/icons.c:	$(ICONS:%=icons/%.hex)

clean::
		rm -f $(ICONS:%=icons/%.hex)

#----- Default page layout ----------------------------------------------------

pl-default.inc:	page_layout_default_description.cpp
		$(BUILD) sed '1,/^extern/d;s/\\\\n/ /' $< >$@ || \
		    { rm -f $@; exit 1; }

kicad/pl-parse.c: pl-default.inc

clean::
		rm -f pl-default.inc

#----- Test sheet -------------------------------------------------------------

sch:
		eeschema test.sch

test:		eeplot
		./eeplot -o out.fig test.lib test.sch
		fig2dev -L png -m 2 out.fig _out.png
		[ ! -r ref.png ] || \
		    compare -metric AE ref.png _out.png _diff.png || \
		    qiv -t -R -D _diff.png ref.png _out.png

testref:	eeplot
		./eeplot -o fig:- test.lib test.sch | \
		    fig2dev -L png -m 2 >ref.png

png:		eeplot
		./eeplot -o _out.png -s 2 test.lib test.sch
		[ ! -r pngref.png ] || \
		    compare -metric AE pngref.png _out.png _diff.png || \
		    qiv -t -R -D _diff.png pngref.png _out.png

pngref:		eeplot
		./eeplot -o pngref.png -s 2 test.lib test.sch

clean::
		rm -f out.fig _out.png _diff.png

#----- Render Neo900 schematics -----------------------------------------------

NEO900_HW = ../../n9/ee/hw
KICAD_LIBS = ../../qi/kicad-libs/components

SHEET ?= 12

neo900:		eeplot
		./eeplot -o out.fig $(NEO900_HW)/neo900.lib \
		    $(KICAD_LIBS)/powered.lib \
		    $(NEO900_HW)/neo900_SS_$(SHEET).sch

neo900.pdf:	eeplot sch2pdf neo900-template.fig
		./sch2pdf -o $@ -t neo900-template.fig \
		    $(NEO900_HW)/neo900.lib $(KICAD_LIBS)/powered.lib \
		    $(NEO900_HW)/neo900.sch

pdf:		eeplot
		./eeplot -o neo900.pdf $(NEO900_HW)/neo900.pro

#----- Regression test based on Neo900 schematics -----------------------------

diff:		eeplot
		test/genpng test out
		test/comp test || $(MAKE) view

view:
		qiv -t -R -D `echo test/_diff*.png | \
		    sed 's/\([^ ]*\)_diff\([^ ]*\)/\1_diff\2 \1ref\2 \1out\2/g'`

newref:
		test/genpng test ref

#----- Memory leak checking ---------------------------------------------------

SUPP = dl-init cairo-font

leak:		eediff
		valgrind --leak-check=full --show-leak-kinds=all \
		    --num-callers=50 \
		    $(SUPP:%=--suppressions=%.supp) \
		    ./eediff $(NEO900_HW)/neo900.pro \
		      $(NEO900_HW)/neo900.pro >/dev/null
#		    ./eeplot -o pdf:- -N 1 $(NEO900_HW)/neo900.pro >/dev/null
#		    ./eeplot -o png:- -N 1 $(NEO900_HW)/neo900.pro >/dev/null

#----- Install / uninstall ---------------------------------------------------

install:	eeshow eeplot eediff eeshow-viewer
		mkdir -p $(DESTDIR)/$(PREFIX)/bin/
		install -m 755 $^ $(DESTDIR)/$(PREFIX)/bin/

uninstall:
		for n in eeshow eeplot eediff; do \
		    rm -f $(DESTDIR)/$(PREFIX)/bin/$$n; done

#----- Cleanup ----------------------------------------------------------------

spotless::
		rm -f eeshow eeplot eediff eetest

=== web/Makefile ===
UPLOAD = wpwrak@neo900.org:pub/eeshow/
SCP = rsync -e "neo900 --ssh" -v

FIGS = wt-start wt-plain wt-pin-type wt-glabel wt-index wt-history wt-diff \
       wt-diff-old wt-diff-new wt-diff-index wt-doc wt-cp

.PHONY:		upload

index.html:	$(FIGS:%=%.png)

%.png:		%.fig
		fig2dev -L png -S 4 $< >$@ || { rm -f $@; exit 1; }

wt-cp.png:	cp.png

#
# @@@ This doesn't work. ImageMagick produces one image per layer, apparently
# unaware of their stacking and the image operations going on between them.
#
# http://stackoverflow.com/questions/630405/converting-xcf-and-other-files-using-command-line-with-gimp
# also suggests xcf2png, which almost succeeds, but still produces an unusable
# image.
#
#cp.png:		cp.xcf
#		convert $< $@ || { rm -f $@; exit 1; }

upload:		$(FIGS:%=%.png)
		$(SCP) index.html $(FIGS:%=%.png) $(UPLOAD)

=== debian/changelog ===
eeshow (0.git20170731-2) experimental; urgency=medium

  * bump standards version and dh compat
  * move package to electronics team and salsa.d.o

 -- W. Martin Borgert <debacle@debian.org>  Sat, 05 May 2018 18:44:25 +0000

eeshow (0.git20170731-1) experimental; urgency=medium

  * new upstream snapshot

 -- W. Martin Borgert <debacle@debian.org>  Sat, 02 Dec 2017 20:27:00 +0000

eeshow (0.git20161102-1) experimental; urgency=low

  * Initial release. (Closes: #842211)

 -- W. Martin Borgert <debacle@debian.org>  Sun, 06 Nov 2016 21:48:00 +0000

=== debian/control ===
Source: eeshow
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: W. Martin Borgert <debacle@debian.org>
Section: electronics
Priority: optional
Build-Depends: debhelper (>= 11),
	fig2dev,
	ghostscript,
	git,
	libgtk-3-dev,
	libcairo2-dev,
	libgit2-dev,
	transfig,
	imagemagick
Standards-Version: 4.1.4
Rules-Requires-Root: no
Homepage: https://neo900.org/stuff/eeshow/
Vcs-Browser: https://salsa.debian.org/electronics-team/KiCad/eeshow
Vcs-Git: https://salsa.debian.org/electronics-team/KiCad/eeshow.git

Package: eeshow
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: xsel
Description: Schematics renderer and viewer for KiCad
 Eeshow is a collection of programs that read schematics made by KiCad
 Eeschema and can be used as interactive viewer, or as a command-line
 tool to convert schematics to PNG, PDF, Postscript, EPS, or FIG.
 .
 Eeshow can show the differences between two versions of schematics
 sheets and it can retrieve files directly from a git repository.
 .
 Eeshow was developed as part of the Neo900 project.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	$(MAKE)
	cd web && $(MAKE)

override_dh_auto_install:
	$(MAKE) install DESTDIR=debian/eeshow PREFIX=/usr
